/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.124 Revision 1.163
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.124 2010/01/31 03:05:54 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.163 2011/08/21 16:14:56 jmbsvicetto Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
16# phase hooks. 16# phase hooks.
17 17
18WANT_AUTOCONF="latest" 18WANT_AUTOCONF="latest"
19WANT_AUTOMAKE="latest" 19WANT_AUTOMAKE="latest"
20 20
21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator 21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator toolchain-funcs
22
23# Shorten the path because the socket path length must be shorter than 107 chars
24# and we will run a mysql server during test phase
25S="${WORKDIR}/mysql"
26
27[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
28if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
29 EGIT_PROJECT=mysql-extras
30 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
31 inherit git
32fi
22 33
23case "${EAPI:-0}" in 34case "${EAPI:-0}" in
24 2) 35 2)
25 EXPORT_FUNCTIONS pkg_setup \ 36 EXPORT_FUNCTIONS pkg_setup \
26 src_unpack src_prepare \ 37 src_unpack src_prepare \
40 ;; 51 ;;
41 *) 52 *)
42 die "Unsupported EAPI: ${EAPI}" ;; 53 die "Unsupported EAPI: ${EAPI}" ;;
43esac 54esac
44 55
45# Shorten the path because the socket path length must be shorter than 107 chars
46# and we will run a mysql server during test phase
47S="${WORKDIR}/mysql"
48 56
49[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z" 57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
50if [[ "${MY_EXTRAS_VER}" == "live" ]]; then 58# @DESCRIPTION:
51 EGIT_PROJECT=mysql-extras 59# Upstream MySQL considers the first two parts of the version number to be the
52 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git" 60# major version. Upgrades that change major version should always run
53 inherit git 61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
64# Cluster is a special case...
65if [[ "${PN}" == "mysql-cluster" ]]; then
66 case $PV in
67 6.1*|7.0*|7.1*) MYSQL_PV_MAJOR=5.1 ;;
68 esac
54fi 69fi
70
55 71
56# @ECLASS-VARIABLE: MYSQL_VERSION_ID 72# @ECLASS-VARIABLE: MYSQL_VERSION_ID
57# @DESCRIPTION: 73# @DESCRIPTION:
58# MYSQL_VERSION_ID will be: 74# MYSQL_VERSION_ID will be:
59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 75# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
77# @DESCRIPTION: 93# @DESCRIPTION:
78# Specifiy if community features are available. Possible values are 1 (yes) 94# Specifiy if community features are available. Possible values are 1 (yes)
79# and 0 (no). 95# and 0 (no).
80# Community features are available in mysql-community 96# Community features are available in mysql-community
81# AND in the re-merged mysql-5.0.82 and newer 97# AND in the re-merged mysql-5.0.82 and newer
82if [ "${PN}" == "mysql-community" ]; then 98if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
83 MYSQL_COMMUNITY_FEATURES=1 99 MYSQL_COMMUNITY_FEATURES=1
84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 100elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
85 MYSQL_COMMUNITY_FEATURES=1 101 MYSQL_COMMUNITY_FEATURES=1
86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 102elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
87 MYSQL_COMMUNITY_FEATURES=1 103 MYSQL_COMMUNITY_FEATURES=1
88elif [ "${PV#5.4}" != "${PV}" ]; then 104elif [ "${PV#5.4}" != "${PV}" ] ; then
105 MYSQL_COMMUNITY_FEATURES=1
106elif [ "${PV#5.5}" != "${PV}" ] ; then
107 MYSQL_COMMUNITY_FEATURES=1
108elif [ "${PV#6}" != "${PV}" ] ; then
109 MYSQL_COMMUNITY_FEATURES=1
110elif [ "${PV#7}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1 111 MYSQL_COMMUNITY_FEATURES=1
90else 112else
91 MYSQL_COMMUNITY_FEATURES=0 113 MYSQL_COMMUNITY_FEATURES=0
92fi 114fi
93 115
108 >=sys-apps/sed-4 130 >=sys-apps/sed-4
109 >=sys-apps/texinfo-4.7-r1 131 >=sys-apps/texinfo-4.7-r1
110 >=sys-libs/readline-4.1 132 >=sys-libs/readline-4.1
111 >=sys-libs/zlib-1.2.3" 133 >=sys-libs/zlib-1.2.3"
112 134
135[[ "${PN}" == "mariadb" ]] \
136&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
137
113# Having different flavours at the same time is not a good idea 138# Having different flavours at the same time is not a good idea
114for i in "" "-community" ; do 139for i in "mysql" "mysql-community" "mysql-cluster" "mariadb" ; do
115 [[ "${i}" == ${PN#mysql} ]] || 140 [[ "${i}" == ${PN} ]] ||
116 DEPEND="${DEPEND} !dev-db/mysql${i}" 141 DEPEND="${DEPEND} !dev-db/${i}"
117done 142done
118 143
119RDEPEND="${DEPEND} 144RDEPEND="${DEPEND}
120 !minimal? ( dev-db/mysql-init-scripts ) 145 !minimal? ( dev-db/mysql-init-scripts )
121 selinux? ( sec-policy/selinux-mysql )" 146 selinux? ( sec-policy/selinux-mysql )"
122 147
148DEPEND="${DEPEND}
149 virtual/yacc"
150
151if [ "${EAPI:-0}" = "2" ]; then
152 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
153fi
154
123# compile-time-only 155# compile-time-only
124mysql_version_is_at_least "5.1" \ 156mysql_version_is_at_least "5.1" \
125|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 157|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
126 158
127# compile-time-only 159# compile-time-only
128mysql_version_is_at_least "5.1.12" \ 160mysql_version_is_at_least "5.1.12" \
129&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 161&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
130 162
163[[ "${PN}" == "mariadb" ]] \
164&& mysql_version_is_at_least "5.2" \
165&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
166#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
167# sphinx? ( app-misc/sphinx )"
168
131# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 169# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
132PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 170PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
133 171
134# For other stuff to bring us in 172# For other stuff to bring us in
135PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 173PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
136 174
137# Work out the default SERVER_URI correctly 175# Work out the default SERVER_URI correctly
138if [ -z "${SERVER_URI}" ]; then 176if [ -z "${SERVER_URI}" ]; then
177 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
178 if [ "${PN}" == "mariadb" ]; then
179 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
180 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
181 SERVER_URI="
182 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
183 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
184 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
185 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
186 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
187 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
188 "
139 # The community build is on the mirrors 189 # The community and cluster builds are on the mirrors
140 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 190 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
141 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz" 191 if [[ "${PN}" == "mysql-cluster" ]] ; then
192 URI_DIR="MySQL-Cluster"
193 URI_FILE="mysql-cluster-gpl"
194 else
195 URI_DIR="MySQL"
196 URI_FILE="mysql"
197 fi
198 URI_A="${URI_FILE}-${MY_PV}.tar.gz"
199 MIRROR_PV=$(get_version_component_range 1-2 ${PV})
200 # Recently upstream switched to an archive site, and not on mirrors
201 SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}
202 mirror://mysql/Downloads/${URI_DIR}-${PV%.*}/${URI_A}"
142 # The (old) enterprise source is on the primary site only 203 # The (old) enterprise source is on the primary site only
143 elif [ "${PN}" == "mysql" ]; then 204 elif [ "${PN}" == "mysql" ]; then
144 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz" 205 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
145 fi 206 fi
146fi 207fi
147 208
148# Define correct SRC_URIs 209# Define correct SRC_URIs
149SRC_URI="${SERVER_URI}" 210SRC_URI="${SERVER_URI}"
153&& SRC_URI="${SRC_URI} 214&& SRC_URI="${SRC_URI}
154 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 215 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
155 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 216 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
156 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 217 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
157 218
158# PBXT engine
159mysql_version_is_at_least "5.1.12" \
160&& [[ -n "${PBXT_VERSION}" ]] \
161&& PBXT_P="pbxt-${PBXT_VERSION}" \
162&& PBXT_SRC_URI="mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
163&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )"
164
165# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
166mysql_version_is_at_least "5.1.26" \
167&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
168&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
169&& XTRADB_SRC_URI="http://www.percona.com/${PN}/xtradb/${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
170&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI} )"
171
172DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 219DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
173HOMEPAGE="http://www.mysql.com/" 220HOMEPAGE="http://www.mysql.com/"
221if [[ "${PN}" == "mariadb" ]]; then
222 HOMEPAGE="http://askmonty.org/"
223 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
224fi
225if [[ "${PN}" == "mysql-community" ]]; then
226 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
227fi
174LICENSE="GPL-2" 228LICENSE="GPL-2"
175SLOT="0" 229SLOT="0"
176IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static" 230IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
177 231
178mysql_version_is_at_least "4.1" \ 232mysql_version_is_at_least "4.1" \
179&& IUSE="${IUSE} latin1" 233&& IUSE="${IUSE} latin1"
180 234
181mysql_version_is_at_least "4.1.3" \ 235if mysql_version_is_at_least "4.1.3" ; then
182&& IUSE="${IUSE} cluster extraengine" 236 IUSE="${IUSE} extraengine"
237 if [[ "${PN}" != "mysql-cluster" ]] ; then
238 IUSE="${IUSE} cluster"
239 fi
240fi
183 241
184mysql_version_is_at_least "5.0" \ 242mysql_version_is_at_least "5.0" \
185|| IUSE="${IUSE} raid" 243|| IUSE="${IUSE} raid"
186 244
187mysql_version_is_at_least "5.0.18" \ 245mysql_version_is_at_least "5.0.18" \
188&& IUSE="${IUSE} max-idx-128" 246&& IUSE="${IUSE} max-idx-128"
189 247
190mysql_version_is_at_least "5.1" \ 248mysql_version_is_at_least "5.1" \
191|| IUSE="${IUSE} berkdb" 249|| IUSE="${IUSE} berkdb"
192 250
193mysql_version_is_at_least "5.1.12" \
194&& [[ -n "${PBXT_VERSION}" ]] \
195&& IUSE="${IUSE} pbxt"
196
197mysql_version_is_at_least "5.1.26" \
198&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
199&& IUSE="${IUSE} xtradb"
200
201[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 251[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
202&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 252&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
253
254[[ "${PN}" == "mariadb" ]] \
255&& IUSE="${IUSE} libevent"
256
257[[ "${PN}" == "mariadb" ]] \
258&& mysql_version_is_at_least "5.2" \
259&& IUSE="${IUSE} oqgraph"
260#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
261#&& IUSE="${IUSE} oqgraph sphinx"
262
263# MariaDB has integrated PBXT
264# PBXT_VERSION means that we have a PBXT patch for this PV
265# PBXT was only introduced after 5.1.12
266pbxt_patch_available() {
267 [[ "${PN}" != "mariadb" ]] \
268 && mysql_version_is_at_least "5.1.12" \
269 && [[ -n "${PBXT_VERSION}" ]]
270 return $?
271}
272
273pbxt_available() {
274 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
275 return $?
276}
277
278# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
279# MariaDB has integrated XtraDB
280# XTRADB_VERS means that we have a XTRADB patch for this PV
281# XTRADB was only introduced after 5.1.26
282xtradb_patch_available() {
283 [[ "${PN}" != "mariadb" ]] \
284 && mysql_version_is_at_least "5.1.26" \
285 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
286 return $?
287}
288
289
290pbxt_patch_available \
291&& PBXT_P="pbxt-${PBXT_VERSION}" \
292&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
293&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
294
295# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
296# vs. built outside the dir
297pbxt_available \
298&& IUSE="${IUSE} pbxt" \
299&& mysql_version_is_at_least "5.1.40" \
300&& PBXT_NEWSTYLE=1
301
302xtradb_patch_available \
303&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
304&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
305&& XTRADB_SRC_B1="http://www.percona.com/" \
306&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
307&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
308&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
309&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
310&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
311&& IUSE="${IUSE} xtradb"
203 312
204# 313#
205# HELPER FUNCTIONS: 314# HELPER FUNCTIONS:
206# 315#
207 316
208# @FUNCTION: mysql_disable_test 317# @FUNCTION: mysql_disable_test
209# @DESCRIPTION: 318# @DESCRIPTION:
210# Helper function to disable specific tests. 319# Helper function to disable specific tests.
211mysql_disable_test() { 320mysql_disable_test() {
321 local rawtestname testname testsuite reason mysql_disable_file
212 local testname="${1}" ; shift 322 rawtestname="${1}" ; shift
213 local reason="${@}" 323 reason="${@}"
324 ewarn "test '${rawtestname}' disabled: '${reason}'"
325
326 testsuite="${rawtestname/.*}"
327 testname="${rawtestname/*.}"
214 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 328 mysql_disable_file="${S}/mysql-test/t/disabled.def"
329 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
215 echo ${testname} : ${reason} >> "${mysql_disable_file}" 330 echo ${testname} : ${reason} >> "${mysql_disable_file}"
216 ewarn "test '${testname}' disabled: '${reason}'" 331
332 # ${S}/mysql-tests/t/disabled.def
333 #
334 # ${S}/mysql-tests/suite/federated/disabled.def
335 #
336 # ${S}/mysql-tests/suite/jp/t/disabled.def
337 # ${S}/mysql-tests/suite/ndb/t/disabled.def
338 # ${S}/mysql-tests/suite/rpl/t/disabled.def
339 # ${S}/mysql-tests/suite/parts/t/disabled.def
340 # ${S}/mysql-tests/suite/rpl_ndb/t/disabled.def
341 # ${S}/mysql-tests/suite/ndb_team/t/disabled.def
342 # ${S}/mysql-tests/suite/binlog/t/disabled.def
343 # ${S}/mysql-tests/suite/innodb/t/disabled.def
344 if [ -n "${testsuite}" ]; then
345 for mysql_disable_file in \
346 ${S}/mysql-test/suite/${testsuite}/disabled.def \
347 ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
348 FAILED ; do
349 [ -f "${mysql_disable_file}" ] && break
350 done
351 if [ "${mysql_disabled_file}" != "FAILED" ]; then
352 echo "${testname} : ${reason}" >> "${mysql_disable_file}"
353 else
354 ewarn "Could not find testsuite disabled.def location for ${rawtestname}"
355 fi
356 fi
217} 357}
218 358
219# @FUNCTION: mysql_init_vars 359# @FUNCTION: mysql_init_vars
220# @DESCRIPTION: 360# @DESCRIPTION:
221# void mysql_init_vars() 361# void mysql_init_vars()
272 MY_DATADIR="${new_MY_DATADIR}" 412 MY_DATADIR="${new_MY_DATADIR}"
273 fi 413 fi
274 fi 414 fi
275 fi 415 fi
276 416
417 if [ "${MY_SOURCEDIR:-unset}" == "unset" ]; then
277 MY_SOURCEDIR=${SERVER_URI##*/} 418 MY_SOURCEDIR=${SERVER_URI##*/}
278 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 419 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
420 fi
279 421
280 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 422 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
281 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 423 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
282 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR 424 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
283} 425}
330 if use debug ; then 472 if use debug ; then
331 myconf="${myconf} --with-debug=full" 473 myconf="${myconf} --with-debug=full"
332 else 474 else
333 myconf="${myconf} --without-debug" 475 myconf="${myconf} --without-debug"
334 mysql_version_is_at_least "4.1.3" \ 476 mysql_version_is_at_least "4.1.3" \
335 && use cluster \ 477 && ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) \
336 && myconf="${myconf} --without-ndb-debug" 478 && myconf="${myconf} --without-ndb-debug"
337 fi 479 fi
338 480
339 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then 481 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
340 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}" 482 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
364 myconf="${myconf} $(use_with perl bench)" 506 myconf="${myconf} $(use_with perl bench)"
365 myconf="${myconf} --enable-assembler" 507 myconf="${myconf} --enable-assembler"
366 myconf="${myconf} --with-extra-tools" 508 myconf="${myconf} --with-extra-tools"
367 myconf="${myconf} --with-innodb" 509 myconf="${myconf} --with-innodb"
368 myconf="${myconf} --without-readline" 510 myconf="${myconf} --without-readline"
511 myconf="${myconf} $(use_with ssl openssl)"
369 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 512 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
370 513
371 # --with-vio is not needed anymore, it's on by default and 514 # --with-vio is not needed anymore, it's on by default and
372 # has been removed from configure 515 # has been removed from configure
516 # Apply to 4.x and 5.0.[0-3]
373 if use ssl ; then 517 if use ssl ; then
374 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 518 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
375 fi
376
377 if mysql_version_is_at_least "5.1.11" ; then
378 myconf="${myconf} $(use_with ssl)"
379 else
380 myconf="${myconf} $(use_with ssl openssl)"
381 fi 519 fi
382 520
383 if mysql_version_is_at_least "5.0.60" ; then 521 if mysql_version_is_at_least "5.0.60" ; then
384 if use berkdb ; then 522 if use berkdb ; then
385 elog "Berkeley DB support was disabled due to build failures" 523 elog "Berkeley DB support was disabled due to build failures"
401 myconf="${myconf} --without-berkeley-db" 539 myconf="${myconf} --without-berkeley-db"
402 fi 540 fi
403 541
404 if mysql_version_is_at_least "4.1.3" ; then 542 if mysql_version_is_at_least "4.1.3" ; then
405 myconf="${myconf} --with-geometry" 543 myconf="${myconf} --with-geometry"
544 if [[ "${PN}" != "mysql-cluster" ]] ; then
406 myconf="${myconf} $(use_with cluster ndbcluster)" 545 myconf="${myconf} $(use_with cluster ndbcluster)"
546 fi
407 fi 547 fi
408 548
409 if mysql_version_is_at_least "4.1.3" && use extraengine ; then 549 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
410 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 550 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
411 myconf="${myconf} --with-archive-storage-engine" 551 myconf="${myconf} --with-archive-storage-engine"
442 582
443configure_51() { 583configure_51() {
444 # TODO: !!!! readd --without-readline 584 # TODO: !!!! readd --without-readline
445 # the failure depend upon config/ac-macros/readline.m4 checking into 585 # the failure depend upon config/ac-macros/readline.m4 checking into
446 # readline.h instead of history.h 586 # readline.h instead of history.h
447 myconf="${myconf} $(use_with ssl)" 587 myconf="${myconf} $(use_with ssl ssl /usr)"
448 myconf="${myconf} --enable-assembler" 588 myconf="${myconf} --enable-assembler"
449 myconf="${myconf} --with-geometry" 589 myconf="${myconf} --with-geometry"
450 myconf="${myconf} --with-readline" 590 myconf="${myconf} --with-readline"
451 myconf="${myconf} --with-row-based-replication"
452 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 591 myconf="${myconf} --with-zlib-dir=/usr/"
453 myconf="${myconf} --without-pstack" 592 myconf="${myconf} --without-pstack"
593 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
594
595 # This is an explict die here, because if we just forcibly disable it, then the
596 # user's data is not accessible.
597 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
454 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 598 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
599 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
600 myconf="${myconf} $(use_enable community community-features)"
601 if use community; then
602 myconf="${myconf} $(use_enable profiling)"
603 else
604 myconf="${myconf} --disable-profiling"
605 fi
606 fi
607
608 # Scan for all available plugins
609 local plugins_avail="$(
610 LANG=C \
611 find "${S}" \
612 \( \
613 -name 'plug.in' \
614 -o -iname 'configure.in' \
615 -o -iname 'configure.ac' \
616 \) \
617 -print0 \
618 | xargs -0 sed -r -n \
619 -e '/^MYSQL_STORAGE_ENGINE/{
620 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
621 s~^([^ ]+).*~\1~gp;
622 }' \
623 | tr -s '\n' ' '
624 )"
455 625
456 # 5.1 introduces a new way to manage storage engines (plugins) 626 # 5.1 introduces a new way to manage storage engines (plugins)
457 # like configuration=none 627 # like configuration=none
628 # This base set are required, and will always be statically built.
458 local plugins="csv,myisam,myisammrg,heap" 629 local plugins_sta="csv myisam myisammrg heap"
630 local plugins_dyn=""
631 local plugins_dis="example ibmdb2i"
632
633 # These aren't actually required by the base set, but are really useful:
634 plugins_sta="${plugins_sta} archive blackhole"
635
636 # default in 5.5.4
637 if mysql_version_is_at_least "5.5.4" ; then
638 plugins_sta="${plugins_sta} partition"
639 fi
640 # Now the extras
459 if use extraengine ; then 641 if use extraengine ; then
460 # like configuration=max-no-ndb, archive and example removed in 5.1.11 642 # like configuration=max-no-ndb, archive and example removed in 5.1.11
461 plugins="${plugins},archive,blackhole,example,federated,partition" 643 # not added yet: ibmdb2i
644 # Not supporting as examples: example,daemon_example,ftexample
645 plugins_sta="${plugins_sta} partition"
462 646
647 if [[ "${PN}" != "mariadb" ]] ; then
463 elog "Before using the Federated storage engine, please be sure to read" 648 elog "Before using the Federated storage engine, please be sure to read"
464 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 649 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
650 plugins_dyn="${plugins_sta} federated"
651 else
652 elog "MariaDB includes the FederatedX engine. Be sure to read"
653 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
654 plugins_dyn="${plugins_sta} federatedx"
465 fi 655 fi
656 else
657 plugins_dis="${plugins_dis} partition federated"
658 fi
466 659
467 # Upstream specifically requests that InnoDB always be built. 660 # Upstream specifically requests that InnoDB always be built:
468 plugins="${plugins},innobase" 661 # - innobase, innodb_plugin
662 # Build falcon if available for 6.x series.
663 for i in innobase falcon ; do
664 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
665 done
666 for i in innodb_plugin ; do
667 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
668 done
469 669
470 # like configuration=max-no-ndb 670 # like configuration=max-no-ndb
471 if use cluster ; then 671 if ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) ; then
472 plugins="${plugins},ndbcluster" 672 plugins_sta="${plugins_sta} ndbcluster partition"
673 plugins_dis="${plugins_dis//partition}"
473 myconf="${myconf} --with-ndb-binlog" 674 myconf="${myconf} --with-ndb-binlog"
675 else
676 plugins_dis="${plugins_dis} ndbcluster"
677 fi
678
679 if [[ "${PN}" == "mariadb" ]] ; then
680 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
681 # caught above.
682 # This is not optional, without it several upstream testcases fail.
683 # Also strongly recommended by upstream.
684 if [[ "${PV}" < "5.2.0" ]] ; then
685 myconf="${myconf} --with-maria-tmp-tables"
686 plugins_sta="${plugins_sta} maria"
687 else
688 myconf="${myconf} --with-aria-tmp-tables"
689 plugins_sta="${plugins_sta} aria"
474 fi 690 fi
475 691
692 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
693 die "The ${P} package doesn't provide innobase nor xtradb"
694
695 for i in innobase xtradb ; do
696 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
697 done
698
699 myconf="${myconf} $(use_with libevent)"
700
476 if mysql_version_is_at_least "5.2" ; then 701 if mysql_version_is_at_least "5.2" ; then
477 plugins="${plugins},falcon" 702 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
703 #for i in oqgraph sphinx ; do
704 for i in oqgraph ; do
705 use ${i} \
706 && plugins_dyn="${plugins_dyn} ${i}" \
707 || plugins_dis="${plugins_dis} ${i}"
708 done
478 fi 709 fi
710 fi
479 711
712 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
713 use pbxt \
714 && plugins_dyn="${plugins_dyn} pbxt" \
715 || plugins_dis="${plugins_dis} pbxt"
716 fi
717
718 use static && \
719 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
720 plugins_dyn=""
721
722 einfo "Available plugins: ${plugins_avail}"
723 einfo "Dynamic plugins: ${plugins_dyn}"
724 einfo "Static plugins: ${plugins_sta}"
725 einfo "Disabled plugins: ${plugins_dis}"
726
727 # These are the static plugins
480 myconf="${myconf} --with-plugins=${plugins}" 728 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
729 # And the disabled ones
730 for i in ${plugins_dis} ; do
731 myconf="${myconf} --without-plugin-${i}"
732 done
481} 733}
482 734
483pbxt_src_configure() { 735pbxt_src_configure() {
484 mysql_init_vars 736 mysql_init_vars
485 737
486 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 738 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
487 739
488 einfo "Reconfiguring dir '${PWD}'" 740 einfo "Reconfiguring dir '${PWD}'"
489 AT_GNUCONF_UPDATE="yes" eautoreconf 741 eautoreconf
490 742
491 local myconf="" 743 local myconf=""
492 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 744 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
493 use debug && myconf="${myconf} --with-debug=full" 745 use debug && myconf="${myconf} --with-debug=full"
494 # TODO: is it safe/needed to use econf here ?
495 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 746 econf ${myconf} || die "Problem configuring PBXT storage engine"
496} 747}
497 748
498pbxt_src_compile() { 749pbxt_src_compile() {
750
499 # Be backwards compatible for now 751 # Be backwards compatible for now
500 if [[ $EAPI != 2 ]]; then 752 if [[ $EAPI != 2 ]]; then
501 pbxt_src_configure 753 pbxt_src_configure
502 fi 754 fi
503 # TODO: is it safe/needed to use emake here ? 755 # TODO: is it safe/needed to use emake here ?
507 # TODO: modify test suite for PBXT 759 # TODO: modify test suite for PBXT
508} 760}
509 761
510pbxt_src_install() { 762pbxt_src_install() {
511 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 763 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
512 make install || die "Failed to install PBXT" 764 emake install DESTDIR="${D}" || die "Failed to install PBXT"
513 popd 765 popd
514} 766}
515 767
516# 768#
517# EBUILD FUNCTIONS 769# EBUILD FUNCTIONS
522# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv" 774# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
523# check for conflicting use flags 775# check for conflicting use flags
524# create new user and group for mysql 776# create new user and group for mysql
525# warn about deprecated features 777# warn about deprecated features
526mysql_pkg_setup() { 778mysql_pkg_setup() {
527 if hasq test ${FEATURES} ; then 779 if has test ${FEATURES} ; then
528 if ! use minimal ; then 780 if ! use minimal ; then
529 if [[ $UID -eq 0 ]]; then 781 if [[ $UID -eq 0 ]]; then
530 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 782 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
531 fi 783 fi
532 fi 784 fi
533 fi 785 fi
534 786
787 # bug 350844
788 case "${EAPI:-0}" in
789 0 | 1)
790 if use static && !built_with_use sys-libs/ncurses static-libs; then
791 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
792 fi
793 ;;
794 esac
795
535 # Check for USE flag problems in pkg_setup 796 # Check for USE flag problems in pkg_setup
536 if use static && use ssl ; then 797 if use static && use ssl ; then
537 eerror "MySQL does not support being built statically with SSL support enabled!"
538 die "MySQL does not support being built statically with SSL support enabled!" 798 M="MySQL does not support being built statically with SSL support enabled!"
799 eerror "${M}"
800 die "${M}"
801 fi
802
803 if mysql_version_is_at_least "5.1.51" \
804 && ! mysql_version_is_at_least "5.2" \
805 && use debug ; then
806 # Also in package.use.mask
807 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
539 fi 808 fi
540 809
541 if ! mysql_version_is_at_least "5.0" \ 810 if ! mysql_version_is_at_least "5.0" \
542 && use raid \ 811 && use raid \
543 && use static ; then 812 && use static ; then
545 eerror "with RAID support enabled." 814 eerror "with RAID support enabled."
546 die "USE flags 'raid' and 'static' conflict!" 815 die "USE flags 'raid' and 'static' conflict!"
547 fi 816 fi
548 817
549 if mysql_version_is_at_least "4.1.3" \ 818 if mysql_version_is_at_least "4.1.3" \
550 && ( use cluster || use extraengine ) \ 819 && ( use cluster || use extraengine || use embedded ) \
551 && use minimal ; then 820 && use minimal ; then
552 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
553 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 821 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
822 eerror "${M}"
823 die "${M}"
824 fi
825
826 if mysql_version_is_at_least "5.1" \
827 && xtradb_patch_available \
828 && use xtradb \
829 && use embedded ; then
830 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
831 eerror "${M}"
832 die "${M}"
833 fi
834
835 # Bug #290570, 284946, 307251
836 # Upstream changes made us need a fairly new GCC4.
837 # But only for 5.0.8[3-6]!
838 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
839 GCC_VER=$(gcc-version)
840 case ${GCC_VER} in
841 2*|3*|4.0|4.1|4.2)
842 eerror "Some releases of MySQL required a very new GCC, and then"
843 eerror "later release relaxed that requirement again. Either pick a"
844 eerror "MySQL >=5.0.87, or use a newer GCC."
845 die "Active GCC too old!" ;;
846 esac
554 fi 847 fi
555 848
556 # This should come after all of the die statements 849 # This should come after all of the die statements
557 enewgroup mysql 60 || die "problem adding 'mysql' group" 850 enewgroup mysql 60 || die "problem adding 'mysql' group"
558 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 851 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
559 852
560 mysql_check_version_range "4.0 to 5.0.99.99" \ 853 mysql_check_version_range "4.0 to 5.0.99.99" \
561 && use berkdb \ 854 && use berkdb \
562 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 855 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
856
857 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
858 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
859 ewarn "5.1 series should NOT be put into production. In the near"
860 ewarn "future, it will be disabled from building."
861 ewarn ""
862 ewarn "If you need NDB support, you should instead move to the new"
863 ewarn "mysql-cluster package that represents that upstream NDB"
864 ewarn "development."
865 fi
563} 866}
564 867
565# @FUNCTION: mysql_src_unpack 868# @FUNCTION: mysql_src_unpack
566# @DESCRIPTION: 869# @DESCRIPTION:
567# Unpack the source code and call mysql_src_prepare for EAPI < 2. 870# Unpack the source code and call mysql_src_prepare for EAPI < 2.
596 # Now link in right patches 899 # Now link in right patches
597 mysql_mv_patches 900 mysql_mv_patches
598 # And apply 901 # And apply
599 epatch 902 epatch
600 903
601 # Additional checks, remove bundled zlib 904 # last -fPIC fixup, per bug #305873
905 i="${S}"/storage/innodb_plugin/plug.in
906 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
907
908 # Additional checks, remove bundled zlib (Cluster needs this, for static
909 # memory management in zlib, leave available for Cluster)
910 if [[ "${PN}" != "mysql-cluster" ]] ; then
602 rm -f "${S}/zlib/"*.[ch] 911 rm -f "${S}/zlib/"*.[ch]
603 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 912 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
913 fi
604 rm -f "scripts/mysqlbug" 914 rm -f "scripts/mysqlbug"
605 915
606 # Make charsets install in the right place 916 # Make charsets install in the right place
607 find . -name 'Makefile.am' \ 917 find . -name 'Makefile.am' \
608 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 918 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
618 rm -f "scripts/mysqlbug" 928 rm -f "scripts/mysqlbug"
619 fi 929 fi
620 930
621 local rebuilddirlist d 931 local rebuilddirlist d
622 932
623 if mysql_version_is_at_least "5.1.26" && use xtradb ; then 933 if xtradb_patch_available && use xtradb ; then
624 einfo "Replacing InnoDB with Percona XtraDB" 934 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
625 pushd "${S}"/storage 935 pushd "${S}"/storage >/dev/null
626 i="innobase" 936 i="innobase"
627 o="${WORKDIR}/storage-${i}.mysql-upstream" 937 o="${WORKDIR}/storage-${i}.mysql-upstream"
628 # Have we been here already? 938 # Have we been here already?
629 [ -h "${i}" ] && rm -f "${i}" 939 [ -d "${o}" ] && rm -f "${i}"
630 # Or maybe we haven't 940 # Or maybe we haven't
631 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 941 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
632 ln -s "${WORKDIR}/${XTRADB_P}" "${i}" 942 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
633 popd 943 popd >/dev/null
944 fi
945
946 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
947 einfo "Adding storage engine: PBXT"
948 pushd "${S}"/storage >/dev/null
949 i='pbxt'
950 [ -d "${i}" ] && rm -rf "${i}"
951 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
952 popd >/dev/null
634 fi 953 fi
635 954
636 if mysql_version_is_at_least "5.1.12" ; then 955 if mysql_version_is_at_least "5.1.12" ; then
637 einfo "Updating innobase cmake"
638 rebuilddirlist="." 956 rebuilddirlist="."
957 # This does not seem to be needed presently. robbat2 2010/02/23
958 #einfo "Updating innobase cmake"
639 # TODO: check this with a cmake expert 959 ## TODO: check this with a cmake expert
640 cmake \ 960 #cmake \
641 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 961 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
642 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \ 962 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
643 "storage/innobase" 963 # "storage/innobase"
644 else 964 else
645 rebuilddirlist=". innobase" 965 rebuilddirlist=". innobase"
646 fi 966 fi
647 967
648 for d in ${rebuilddirlist} ; do 968 for d in ${rebuilddirlist} ; do
649 einfo "Reconfiguring dir '${d}'" 969 einfo "Reconfiguring dir '${d}'"
650 pushd "${d}" &>/dev/null 970 pushd "${d}" &>/dev/null
651 AT_GNUCONF_UPDATE="yes" eautoreconf 971 eautoreconf
652 popd &>/dev/null 972 popd &>/dev/null
653 done 973 done
654 974
655 if mysql_check_version_range "4.1 to 5.0.99.99" \ 975 if mysql_check_version_range "4.1 to 5.0.99.99" \
656 && use berkdb ; then 976 && use berkdb ; then
712 export CXXFLAGS 1032 export CXXFLAGS
713 1033
714 # bug #283926, with GCC4.4, this is required to get correct behavior. 1034 # bug #283926, with GCC4.4, this is required to get correct behavior.
715 append-flags -fno-strict-aliasing 1035 append-flags -fno-strict-aliasing
716 1036
1037 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1038 # causes a mis-compile.
1039 # Upstream bugs:
1040 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1041 # http://bugs.mysql.com/bug.php?id=45205
1042 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1043 append-flags -fno-omit-frame-pointer && \
1044 filter-flags -fomit-frame-pointer
1045
717 econf \ 1046 econf \
718 --libexecdir="/usr/sbin" \ 1047 --libexecdir="/usr/sbin" \
719 --sysconfdir="${MY_SYSCONFDIR}" \ 1048 --sysconfdir="${MY_SYSCONFDIR}" \
720 --localstatedir="${MY_LOCALSTATEDIR}" \ 1049 --localstatedir="${MY_LOCALSTATEDIR}" \
721 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 1050 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
724 --with-low-memory \ 1053 --with-low-memory \
725 --with-client-ldflags=-lstdc++ \ 1054 --with-client-ldflags=-lstdc++ \
726 --enable-thread-safe-client \ 1055 --enable-thread-safe-client \
727 --with-comment="Gentoo Linux ${PF}" \ 1056 --with-comment="Gentoo Linux ${PF}" \
728 --without-docs \ 1057 --without-docs \
1058 --with-LIBDIR="$(get_libdir)" \
729 ${myconf} || die "econf failed" 1059 ${myconf} || die "econf failed"
730 1060
731 # TODO: Move this before autoreconf !!! 1061 # TODO: Move this before autoreconf !!!
732 find . -type f -name Makefile -print0 \ 1062 find . -type f -name Makefile -print0 \
733 | xargs -0 -n100 sed -i \ 1063 | xargs -0 -n100 sed -i \
734 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 1064 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
735 1065
736 if [[ $EAPI == 2 ]]; then 1066 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
737 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure 1067 pbxt_patch_available && use pbxt && pbxt_src_configure
738 fi 1068 fi
739} 1069}
740 1070
741# @FUNCTION: mysql_src_compile 1071# @FUNCTION: mysql_src_compile
742# @DESCRIPTION: 1072# @DESCRIPTION:
743# Compile the mysql code. 1073# Compile the mysql code.
744mysql_src_compile() { 1074mysql_src_compile() {
745 # Be backwards compatible for now 1075 # Be backwards compatible for now
746 case ${EAPI:-0} in 1076 case ${EAPI:-0} in
747 2) : ;; 1077 2) : ;;
748 0 | 1) mysql_src_configure ;; 1078 0 | 1) mysql_src_configure ;;
749 esac 1079 esac
750 1080
751 emake || die "emake failed" 1081 emake || die "emake failed"
752 1082
753 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 1083 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1084 pbxt_patch_available && use pbxt && pbxt_src_compile
1085 fi
754} 1086}
755 1087
756# @FUNCTION: mysql_src_install 1088# @FUNCTION: mysql_src_install
757# @DESCRIPTION: 1089# @DESCRIPTION:
758# Install mysql. 1090# Install mysql.
759mysql_src_install() { 1091mysql_src_install() {
760 # Make sure the vars are correctly initialized 1092 # Make sure the vars are correctly initialized
761 mysql_init_vars 1093 mysql_init_vars
762 1094
763 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 1095 emake install \
1096 DESTDIR="${D}" \
1097 benchdir_root="${MY_SHAREDSTATEDIR}" \
1098 testroot="${MY_SHAREDSTATEDIR}" \
1099 || die "emake install failed"
764 1100
765 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 1101 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1102 pbxt_patch_available && use pbxt && pbxt_src_install
1103 fi
766 1104
767 # Convenience links 1105 # Convenience links
768 einfo "Making Convenience links for mysqlcheck multi-call binary" 1106 einfo "Making Convenience links for mysqlcheck multi-call binary"
769 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 1107 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
770 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1108 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
774 einfo "Removing duplicate /usr/share/mysql files" 1112 einfo "Removing duplicate /usr/share/mysql files"
775 rm -Rf "${D}/usr/share/info" 1113 rm -Rf "${D}/usr/share/info"
776 for removeme in "mysql-log-rotate" mysql.server* \ 1114 for removeme in "mysql-log-rotate" mysql.server* \
777 binary-configure* my-*.cnf mi_test_all* 1115 binary-configure* my-*.cnf mi_test_all*
778 do 1116 do
779 rm -f "${D}"/usr/share/mysql/${removeme} 1117 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
780 done 1118 done
781 1119
782 # Clean up stuff for a minimal build 1120 # Clean up stuff for a minimal build
783 if use minimal ; then 1121 if use minimal ; then
784 einfo "Remove all extra content for minimal build" 1122 einfo "Remove all extra content for minimal build"
786 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 1124 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
787 rm -f "${D}/usr/sbin/mysqld" 1125 rm -f "${D}/usr/sbin/mysqld"
788 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 1126 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
789 fi 1127 fi
790 1128
1129 # Unless they explicitly specific USE=test, then do not install the
1130 # testsuite. It DOES have a use to be installed, esp. when you want to do a
1131 # validation of your database configuration after tuning it.
1132 if use !test ; then
1133 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1134 fi
1135
791 # Configuration stuff 1136 # Configuration stuff
792 if mysql_version_is_at_least "4.1" ; then 1137 case ${MYSQL_PV_MAJOR} in
793 mysql_mycnf_version="4.1"
794 else
795 mysql_mycnf_version="4.0" 1138 3*|4.0) mysql_mycnf_version="4.0" ;;
796 fi 1139 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
797 einfo "Building default my.cnf" 1140 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1141 esac
1142 einfo "Building default my.cnf (${mysql_mycnf_version})"
798 insinto "${MY_SYSCONFDIR}" 1143 insinto "${MY_SYSCONFDIR}"
799 doins scripts/mysqlaccess.conf 1144 doins scripts/mysqlaccess.conf
1145 mycnf_src="my.cnf-${mysql_mycnf_version}"
800 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1146 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
801 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1147 "${FILESDIR}/${mycnf_src}" \
802 > "${TMPDIR}/my.cnf.ok" 1148 > "${TMPDIR}/my.cnf.ok"
803 if mysql_version_is_at_least "4.1" && use latin1 ; then 1149 if use latin1 ; then
804 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1150 sed -i \
1151 -e "/character-set/s|utf8|latin1|g" \
1152 "${TMPDIR}/my.cnf.ok"
805 fi 1153 fi
806 newins "${TMPDIR}/my.cnf.ok" my.cnf 1154 newins "${TMPDIR}/my.cnf.ok" my.cnf
807 1155
808 # Minimal builds don't have the MySQL server 1156 # Minimal builds don't have the MySQL server
809 if ! use minimal ; then 1157 if ! use minimal ; then
824 done 1172 done
825 fi 1173 fi
826 1174
827 # Docs 1175 # Docs
828 einfo "Installing docs" 1176 einfo "Installing docs"
829 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1177 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1178 [[ -f "$i" ]] && dodoc "$i"
1179 done
830 doinfo "${S}"/Docs/mysql.info 1180 doinfo "${S}"/Docs/mysql.info
831 1181
832 # Minimal builds don't have the MySQL server 1182 # Minimal builds don't have the MySQL server
833 if ! use minimal ; then 1183 if ! use minimal ; then
834 einfo "Including support files and sample configurations" 1184 einfo "Including support files and sample configurations"
836 for script in \ 1186 for script in \
837 "${S}"/support-files/my-*.cnf \ 1187 "${S}"/support-files/my-*.cnf \
838 "${S}"/support-files/magic \ 1188 "${S}"/support-files/magic \
839 "${S}"/support-files/ndb-config-2-node.ini 1189 "${S}"/support-files/ndb-config-2-node.ini
840 do 1190 do
841 dodoc "${script}" 1191 [[ -f "$script" ]] && dodoc "${script}"
842 done 1192 done
843 1193
844 docinto "scripts" 1194 docinto "scripts"
845 for script in "${S}"/scripts/mysql* ; do 1195 for script in "${S}"/scripts/mysql* ; do
846 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1196 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
847 done 1197 done
848 1198
849 fi 1199 fi
850 1200
851 mysql_lib_symlinks "${D}" 1201 mysql_lib_symlinks "${D}"
885 for script in \ 1235 for script in \
886 support-files/my-*.cnf \ 1236 support-files/my-*.cnf \
887 support-files/magic \ 1237 support-files/magic \
888 support-files/ndb-config-2-node.ini 1238 support-files/ndb-config-2-node.ini
889 do 1239 do
1240 [[ -f "${script}" ]] \
890 dodoc "${script}" 1241 && dodoc "${script}"
891 done 1242 done
892 1243
893 docinto "scripts" 1244 docinto "scripts"
894 for script in scripts/mysql* ; do 1245 for script in scripts/mysql* ; do
1246 [[ -f "${script}" ]] \
895 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1247 && [[ "${script%.sh}" == "${script}" ]] \
1248 && dodoc "${script}"
896 done 1249 done
897 1250
898 einfo 1251 einfo
899 elog "You might want to run:" 1252 elog "You might want to run:"
900 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1253 elog "\"emerge --config =${CATEGORY}/${PF}\""
901 elog "if this is a new install." 1254 elog "if this is a new install."
902 einfo 1255 einfo
903 fi
904 1256
905 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 1257 einfo
1258 elog "If you are upgrading major versions, you should run the"
1259 elog "mysql_upgrade tool."
1260 einfo
1261 fi
1262
1263 if pbxt_available && use pbxt ; then
906 # TODO: explain it better 1264 # TODO: explain it better
907 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1265 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
908 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1266 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
909 elog "if, after that, you cannot start the MySQL server," 1267 elog "if, after that, you cannot start the MySQL server,"
910 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1268 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
961 fi 1319 fi
962 fi 1320 fi
963 1321
964 local pwd1="a" 1322 local pwd1="a"
965 local pwd2="b" 1323 local pwd2="b"
966 local maxtry=5 1324 local maxtry=15
1325
1326 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1327 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1328 fi
967 1329
968 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1330 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
969 ewarn "You have already a MySQL database in place." 1331 ewarn "You have already a MySQL database in place."
970 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1332 ewarn "(${ROOT}/${MY_DATADIR}/*)"
971 ewarn "Please rename or delete it if you wish to replace it." 1333 ewarn "Please rename or delete it if you wish to replace it."
974 1336
975 # Bug #213475 - MySQL _will_ object strenously if your machine is named 1337 # Bug #213475 - MySQL _will_ object strenously if your machine is named
976 # localhost. Also causes weird failures. 1338 # localhost. Also causes weird failures.
977 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1339 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
978 1340
979 einfo "Creating the mysql database and setting proper" 1341 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
980 einfo "permissions on it ..."
981 1342
982 einfo "Insert a password for the mysql 'root' user" 1343 einfo "Please provide a password for the mysql 'root' user now, in the"
1344 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
983 ewarn "Avoid [\"'\\_%] characters in the password" 1345 ewarn "Avoid [\"'\\_%] characters in the password"
984 read -rsp " >" pwd1 ; echo 1346 read -rsp " >" pwd1 ; echo
985 1347
986 einfo "Retype the password" 1348 einfo "Retype the password"
987 read -rsp " >" pwd2 ; echo 1349 read -rsp " >" pwd2 ; echo
988 1350
989 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1351 if [[ "x$pwd1" != "x$pwd2" ]] ; then
990 die "Passwords are not the same" 1352 die "Passwords are not the same"
1353 fi
1354 MYSQL_ROOT_PASSWORD="${pwd1}"
1355 unset pwd1 pwd2
991 fi 1356 fi
992 1357
993 local options="" 1358 local options=""
994 local sqltmp="$(emktemp)" 1359 local sqltmp="$(emktemp)"
995 1360
1009 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1374 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
1010 || die "MySQL databases not installed" 1375 || die "MySQL databases not installed"
1011 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null 1376 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
1012 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null 1377 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
1013 1378
1379 # Figure out which options we need to disable to do the setup
1380 helpfile="${TMPDIR}/mysqld-help"
1381 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1382 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1383 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1384 ndbcluster \
1385 ; do
1386 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1387 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1388 done
1389 # But some options changed names
1390 egrep -sq external-locking "${helpfile}" && \
1391 options="${options/skip-locking/skip-external-locking}"
1392
1014 if mysql_version_is_at_least "4.1.3" ; then 1393 if mysql_version_is_at_least "4.1.3" ; then
1015 options="--skip-ndbcluster"
1016
1017 # Filling timezones, see 1394 # Filling timezones, see
1018 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1395 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
1019 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1396 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
1020 1397
1021 if [[ -r "${help_tables}" ]] ; then 1398 if [[ -r "${help_tables}" ]] ; then
1022 cat "${help_tables}" >> "${sqltmp}" 1399 cat "${help_tables}" >> "${sqltmp}"
1023 fi 1400 fi
1024 fi 1401 fi
1402
1403 einfo "Creating the mysql database and setting proper"
1404 einfo "permissions on it ..."
1025 1405
1026 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1406 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1027 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1407 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
1028 local mysqld="${ROOT}/usr/sbin/mysqld \ 1408 local mysqld="${ROOT}/usr/sbin/mysqld \
1029 ${options} \ 1409 ${options} \
1030 --user=mysql \ 1410 --user=mysql \
1031 --skip-grant-tables \
1032 --basedir=${ROOT}/usr \ 1411 --basedir=${ROOT}/usr \
1033 --datadir=${ROOT}/${MY_DATADIR} \ 1412 --datadir=${ROOT}/${MY_DATADIR} \
1034 --skip-innodb \
1035 --skip-bdb \
1036 --skip-networking \
1037 --max_allowed_packet=8M \ 1413 --max_allowed_packet=8M \
1038 --net_buffer_length=16K \ 1414 --net_buffer_length=16K \
1415 --default-storage-engine=MyISAM \
1039 --socket=${socket} \ 1416 --socket=${socket} \
1040 --pid-file=${pidfile}" 1417 --pid-file=${pidfile}"
1418 #einfo "About to start mysqld: ${mysqld}"
1419 ebegin "Starting mysqld"
1041 ${mysqld} & 1420 ${mysqld} &
1421 rc=$?
1042 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1422 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
1043 maxtry=$((${maxtry}-1)) 1423 maxtry=$((${maxtry}-1))
1044 echo -n "." 1424 echo -n "."
1045 sleep 1 1425 sleep 1
1046 done 1426 done
1427 eend $rc
1047 1428
1429 if ! [[ -S "${socket}" ]]; then
1430 die "Completely failed to start up mysqld with: ${mysqld}"
1431 fi
1432
1433 ebegin "Setting root password"
1048 # Do this from memory, as we don't want clear text passwords in temp files 1434 # Do this from memory, as we don't want clear text passwords in temp files
1049 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1435 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
1050 "${ROOT}/usr/bin/mysql" \ 1436 "${ROOT}/usr/bin/mysql" \
1051 --socket=${socket} \ 1437 --socket=${socket} \
1052 -hlocalhost \ 1438 -hlocalhost \
1053 -e "${sql}" 1439 -e "${sql}"
1440 eend $?
1054 1441
1055 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1442 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
1056
1057 "${ROOT}/usr/bin/mysql" \ 1443 "${ROOT}/usr/bin/mysql" \
1058 --socket=${socket} \ 1444 --socket=${socket} \
1059 -hlocalhost \ 1445 -hlocalhost \
1060 -uroot \ 1446 -uroot \
1061 -p"${pwd1}" \ 1447 -p"${MYSQL_ROOT_PASSWORD}" \
1062 mysql < "${sqltmp}" 1448 mysql < "${sqltmp}"
1449 rc=$?
1450 eend $?
1451 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
1063 1452
1064 # Stop the server and cleanup 1453 # Stop the server and cleanup
1454 einfo "Stopping the server ..."
1065 kill $(< "${pidfile}" ) 1455 kill $(< "${pidfile}" )
1066 rm -f "${sqltmp}" 1456 rm -f "${sqltmp}"
1067 einfo "Stopping the server ..."
1068 wait %1 1457 wait %1
1069 einfo "Done" 1458 einfo "Done"
1070} 1459}
1071 1460
1072# @FUNCTION: mysql_pkg_postrm 1461# @FUNCTION: mysql_pkg_postrm

Legend:
Removed from v.1.124  
changed lines
  Added in v.1.163

  ViewVC Help
Powered by ViewVC 1.1.20